// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from performance_test:msg/FixedTime.idl
// generated code does not contain a copyright notice
#include "performance_test/msg/detail/fixed_time__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
performance_test__msg__FixedTime__init(performance_test__msg__FixedTime * msg)
{
  if (!msg) {
    return false;
  }
  // sec
  // nanosec
  return true;
}

void
performance_test__msg__FixedTime__fini(performance_test__msg__FixedTime * msg)
{
  if (!msg) {
    return;
  }
  // sec
  // nanosec
}

bool
performance_test__msg__FixedTime__are_equal(const performance_test__msg__FixedTime * lhs, const performance_test__msg__FixedTime * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // sec
  if (lhs->sec != rhs->sec) {
    return false;
  }
  // nanosec
  if (lhs->nanosec != rhs->nanosec) {
    return false;
  }
  return true;
}

bool
performance_test__msg__FixedTime__copy(
  const performance_test__msg__FixedTime * input,
  performance_test__msg__FixedTime * output)
{
  if (!input || !output) {
    return false;
  }
  // sec
  output->sec = input->sec;
  // nanosec
  output->nanosec = input->nanosec;
  return true;
}

performance_test__msg__FixedTime *
performance_test__msg__FixedTime__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__FixedTime * msg = (performance_test__msg__FixedTime *)allocator.allocate(sizeof(performance_test__msg__FixedTime), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(performance_test__msg__FixedTime));
  bool success = performance_test__msg__FixedTime__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
performance_test__msg__FixedTime__destroy(performance_test__msg__FixedTime * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    performance_test__msg__FixedTime__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
performance_test__msg__FixedTime__Sequence__init(performance_test__msg__FixedTime__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__FixedTime * data = NULL;

  if (size) {
    data = (performance_test__msg__FixedTime *)allocator.zero_allocate(size, sizeof(performance_test__msg__FixedTime), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = performance_test__msg__FixedTime__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        performance_test__msg__FixedTime__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
performance_test__msg__FixedTime__Sequence__fini(performance_test__msg__FixedTime__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      performance_test__msg__FixedTime__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

performance_test__msg__FixedTime__Sequence *
performance_test__msg__FixedTime__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__FixedTime__Sequence * array = (performance_test__msg__FixedTime__Sequence *)allocator.allocate(sizeof(performance_test__msg__FixedTime__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = performance_test__msg__FixedTime__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
performance_test__msg__FixedTime__Sequence__destroy(performance_test__msg__FixedTime__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    performance_test__msg__FixedTime__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
performance_test__msg__FixedTime__Sequence__are_equal(const performance_test__msg__FixedTime__Sequence * lhs, const performance_test__msg__FixedTime__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!performance_test__msg__FixedTime__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
performance_test__msg__FixedTime__Sequence__copy(
  const performance_test__msg__FixedTime__Sequence * input,
  performance_test__msg__FixedTime__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(performance_test__msg__FixedTime);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    performance_test__msg__FixedTime * data =
      (performance_test__msg__FixedTime *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!performance_test__msg__FixedTime__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          performance_test__msg__FixedTime__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!performance_test__msg__FixedTime__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
