// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from performance_test:msg/PointCloud2m.idl
// generated code does not contain a copyright notice

#ifndef PERFORMANCE_TEST__MSG__DETAIL__POINT_CLOUD2M__STRUCT_HPP_
#define PERFORMANCE_TEST__MSG__DETAIL__POINT_CLOUD2M__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "performance_test/msg/detail/fixed_header__struct.hpp"
// Member 'fields'
#include "performance_test/msg/detail/fixed_point_field__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__performance_test__msg__PointCloud2m __attribute__((deprecated))
#else
# define DEPRECATED__performance_test__msg__PointCloud2m __declspec(deprecated)
#endif

namespace performance_test
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PointCloud2m_
{
  using Type = PointCloud2m_<ContainerAllocator>;

  explicit PointCloud2m_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->height = 0ul;
      this->width = 0ul;
      this->fields.fill(performance_test::msg::FixedPointField_<ContainerAllocator>{_init});
      this->is_bigendian = false;
      this->point_step = 0ul;
      this->row_step = 0ul;
      std::fill<typename std::array<unsigned char, 2097152>::iterator, unsigned char>(this->data.begin(), this->data.end(), 0);
      this->is_dense = false;
      this->time = 0ll;
      this->id = 0ull;
    }
  }

  explicit PointCloud2m_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    fields(_alloc),
    data(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->height = 0ul;
      this->width = 0ul;
      this->fields.fill(performance_test::msg::FixedPointField_<ContainerAllocator>{_alloc, _init});
      this->is_bigendian = false;
      this->point_step = 0ul;
      this->row_step = 0ul;
      std::fill<typename std::array<unsigned char, 2097152>::iterator, unsigned char>(this->data.begin(), this->data.end(), 0);
      this->is_dense = false;
      this->time = 0ll;
      this->id = 0ull;
    }
  }

  // field types and members
  using _header_type =
    performance_test::msg::FixedHeader_<ContainerAllocator>;
  _header_type header;
  using _height_type =
    uint32_t;
  _height_type height;
  using _width_type =
    uint32_t;
  _width_type width;
  using _fields_type =
    std::array<performance_test::msg::FixedPointField_<ContainerAllocator>, 8>;
  _fields_type fields;
  using _is_bigendian_type =
    bool;
  _is_bigendian_type is_bigendian;
  using _point_step_type =
    uint32_t;
  _point_step_type point_step;
  using _row_step_type =
    uint32_t;
  _row_step_type row_step;
  using _data_type =
    std::array<unsigned char, 2097152>;
  _data_type data;
  using _is_dense_type =
    bool;
  _is_dense_type is_dense;
  using _time_type =
    int64_t;
  _time_type time;
  using _id_type =
    uint64_t;
  _id_type id;

  // setters for named parameter idiom
  Type & set__header(
    const performance_test::msg::FixedHeader_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__height(
    const uint32_t & _arg)
  {
    this->height = _arg;
    return *this;
  }
  Type & set__width(
    const uint32_t & _arg)
  {
    this->width = _arg;
    return *this;
  }
  Type & set__fields(
    const std::array<performance_test::msg::FixedPointField_<ContainerAllocator>, 8> & _arg)
  {
    this->fields = _arg;
    return *this;
  }
  Type & set__is_bigendian(
    const bool & _arg)
  {
    this->is_bigendian = _arg;
    return *this;
  }
  Type & set__point_step(
    const uint32_t & _arg)
  {
    this->point_step = _arg;
    return *this;
  }
  Type & set__row_step(
    const uint32_t & _arg)
  {
    this->row_step = _arg;
    return *this;
  }
  Type & set__data(
    const std::array<unsigned char, 2097152> & _arg)
  {
    this->data = _arg;
    return *this;
  }
  Type & set__is_dense(
    const bool & _arg)
  {
    this->is_dense = _arg;
    return *this;
  }
  Type & set__time(
    const int64_t & _arg)
  {
    this->time = _arg;
    return *this;
  }
  Type & set__id(
    const uint64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    performance_test::msg::PointCloud2m_<ContainerAllocator> *;
  using ConstRawPtr =
    const performance_test::msg::PointCloud2m_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<performance_test::msg::PointCloud2m_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<performance_test::msg::PointCloud2m_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      performance_test::msg::PointCloud2m_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<performance_test::msg::PointCloud2m_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      performance_test::msg::PointCloud2m_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<performance_test::msg::PointCloud2m_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<performance_test::msg::PointCloud2m_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<performance_test::msg::PointCloud2m_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__performance_test__msg__PointCloud2m
    std::shared_ptr<performance_test::msg::PointCloud2m_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__performance_test__msg__PointCloud2m
    std::shared_ptr<performance_test::msg::PointCloud2m_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PointCloud2m_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->height != other.height) {
      return false;
    }
    if (this->width != other.width) {
      return false;
    }
    if (this->fields != other.fields) {
      return false;
    }
    if (this->is_bigendian != other.is_bigendian) {
      return false;
    }
    if (this->point_step != other.point_step) {
      return false;
    }
    if (this->row_step != other.row_step) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    if (this->is_dense != other.is_dense) {
      return false;
    }
    if (this->time != other.time) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    return true;
  }
  bool operator!=(const PointCloud2m_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PointCloud2m_

// alias to use template instance with default allocator
using PointCloud2m =
  performance_test::msg::PointCloud2m_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace performance_test

#endif  // PERFORMANCE_TEST__MSG__DETAIL__POINT_CLOUD2M__STRUCT_HPP_
